module RackCheck::Spec
  include RackCheck

  class Context
    attr_reader :app_server_command, :app_server_port, :startup_timeout

    def initialize(app_server_command, app_server_port, startup_timeout)
      @app_server_port = app_server_port
      @app_server_command = app_server_command
      @startup_timeout = startup_timeout
    end
  end

  STARTUP_TIMEOUT = 10

  def self.run(app_server_command, app_server_port)
    load_tests
    @@context = Context.new(app_server_command, app_server_port, STARTUP_TIMEOUT)

    # TODO there must be a better way to pass context to a rspec suite
    RSpec::Core::Runner.run([])
  end

  def self.server_context
    @@context
  end

  def self.load_tests
    require 'rack_check/spec/rackup'
    require 'rack_check/spec/env'
  end
end
